﻿------------------------------------------------------------------------------------------
--Combo Point-----------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, LSM, _ = unpack(select(2,...))
local BORDER = 2
local CLASSBAR_WIDTH = 269 - (BORDER*2)

local GetComboPoints = GetComboPoints
local MAX_COMBO_POINTS = MAX_COMBO_POINTS

function SN:CPoints(frame)
	--local m = SNmedia
	local SNd = SN.data.profile
	local color = LSM.classResources.ROGUE

	local points = CreateFrame("Frame", nil, frame)
	points:SetSize(CLASSBAR_WIDTH, 16)
	points:SetPoint("CENTER", frame, "CENTER", 0, 0)

	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(points)
	else
		points:SetBackdrop({
		bgFile = LSM.media.blankTex, 
		edgeFile = LSM.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 4, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		points:SetBackdropColor(0.1, 0.1, 0.1, 0.3)
		points:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end

	for i = 1, MAX_COMBO_POINTS do
		points[i] = CreateFrame("StatusBar", nil, points)
		points[i]:SetSize((points:GetWidth() - 16) / MAX_COMBO_POINTS, points:GetHeight())

		if i == 1 then
			points[i]:SetPoint("LEFT", points)
		else
			points[i]:SetPoint("LEFT", points[(i - 1)], "RIGHT", 4, 0)
		end
		
		points[i]:SetStatusBarTexture(LSM.media.minTex)
		points[i]:GetStatusBarTexture():SetHorizTile(false)
		points[i]:SetMinMaxValues(0, 1)
		points[i]:SetStatusBarColor(unpack(color[i]))
	
	end
	
	return points
end

function SN:SetupCombo()
	SN:Debug("Checking to see if we are a rogue or a druid")
	local class = select(2, UnitClass("player"))
	SN:Debug("I am a "..class)
	if class == "ROGUE" or class == "DRUID" then
		SN:Debug("Let's start up some combo points")

		local SNd = SN.data.profile
		local frame = F.classpower

		frame.points = SN:CPoints(frame)
		F.classpower.frame = frame.points
		frame.points:RegisterEvent("UNIT_COMBO_POINTS")
		frame.points:RegisterEvent("PLAYER_TARGET_CHANGED")
		frame.points:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		frame.points:RegisterEvent("PLAYER_ALIVE")

		frame.points:SetScript("OnEvent", function(self, event, ...)
			if event == "UNIT_COMBO_POINTS" then
				local cpoints = GetComboPoints("player", "target")
				if cpoints > 0 then
					for i = 1, cpoints do
						self[i]:SetValue(1)
					end
				else
					for i = 1, MAX_COMBO_POINTS do
						self[i]:SetValue(0)
					end
				end
			elseif event == "PLAYER_TARGET_CHANGED" then
				local cpoints = GetComboPoints("player", "target")
				if cpoints > 0 then
					for i = 1, cpoints do
						self[i]:SetValue(1)
					end
				else
					for i = 1, MAX_COMBO_POINTS do
						self[i]:SetValue(0)
					end
				end
			end

			if event == "UPDATE_SHAPESHIFT_FORM" then
				local form = GetShapeshiftFormID()
				SN:Debug(form)
				if form == CAT_FORM then
					SN:ComboEnable()
				else
					SN:ComboDisable()
				end
			end
		
			if event == "PLAYER_ALIVE" then
				local form = GetShapeshiftFormID()
				local class = select(2, UnitClass("player"))
				if class == "DRUID" and form == CAT_FORM then
					SN:ComboEnable()
				else
					SN:ComboDisable()
				end
			end
		end)
		local cpoints = GetComboPoints("player", "target")

		if cpoints > 0 then
			for i = 1, cpoints do
				frame.points[i]:SetValue(1)
			end
		else
			for i = 1, MAX_COMBO_POINTS do
				frame.points[i]:SetValue(0)
			end
		end
		if not SNd.classResources.enable then 
			SN:ComboDisable()
		end
	end
end

function SN:ComboEnable()
	local frame = F.classpower
	frame.points:Show()
	frame.points:RegisterEvent("UNIT_COMBO_POINTS")
	frame.points:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function SN:ComboDisable()
	local frame = F.classpower
	frame.points:UnregisterEvent("UNIT_COMBO_POINTS")
	frame.points:UnregisterEvent("PLAYER_TARGET_CHANGED")
	frame.points:Hide()
	collectgarbage("collect")
end